// Generated by IcedCoffeeScript 108.0.11
var ShiftCheckbox, Spine,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

Spine = require("spine");

ShiftCheckbox = (function(_super) {
  __extends(ShiftCheckbox, _super);

  ShiftCheckbox.prototype.selectAllClass = "scb-select-all";

  ShiftCheckbox.prototype.selectedClass = "scb-selected";

  ShiftCheckbox.prototype.lastIndex = -1;

  ShiftCheckbox.prototype._targetFromEvent = function(e) {
    return $(e.target);
  };

  ShiftCheckbox.prototype.allCheckboxes = function() {
    return this.$(":checkbox");
  };

  ShiftCheckbox.prototype.checkboxes = function() {
    return this.allCheckboxes().not("." + this.selectAllClass);
  };

  ShiftCheckbox.prototype.checked = function() {
    return this.checkboxes().filter(":checked");
  };

  ShiftCheckbox.prototype.selectAll = function(e) {
    return this.allCheckboxes().prop({
      checked: true
    }).trigger("change");
  };

  ShiftCheckbox.prototype.deselectAll = function(e) {
    return this.allCheckboxes().prop({
      checked: false
    }).trigger("change");
  };

  ShiftCheckbox.prototype.selectOrDeselectAll = function(e) {
    var checkboxes;
    checkboxes = this.checkboxes();
    if ((checkboxes.not(":checked")).length) {
      this.selectAll(e);
    } else {
      this.deselectAll(e);
    }
    return this.trigger("change", checkboxes);
  };

  ShiftCheckbox.prototype.selectOneOrRange = function(e) {
    var $target, changed, checkbox, checkboxes, di, i, index;
    $target = this._targetFromEvent(e);
    checkboxes = this.checkboxes();
    index = checkboxes.index($target);
    changed = $target;
    if (e.shiftKey && this.lastIndex !== -1) {
      di = index > this.lastIndex ? 1 : -1;
      i = this.lastIndex;
      while (i !== index) {
        checkbox = checkboxes.eq(i);
        checkbox.prop({
          checked: "checked"
        });
        checkbox.trigger("change");
        changed.add(checkbox);
        i += di;
      }
    }
    this.lastIndex = index;
    return this.trigger("change", changed);
  };

  ShiftCheckbox.prototype.selectOneOrMany = function(e) {
    var $target;
    $target = this._targetFromEvent(e);
    if ($target.hasClass(this.selectAllClass)) {
      return this.selectOrDeselectAll(e);
    } else {
      return this.selectOneOrRange(e);
    }
  };

  ShiftCheckbox.prototype.updateParentClass = function(e) {
    var $parent, $target;
    $target = this._targetFromEvent(e);
    if ($target.hasClass(this.selectAllClass)) {
      return;
    }
    $parent = $target.closest(this.parentSelector);
    if ($target.is(":checked")) {
      return $parent.addClass(this.selectedClass);
    } else {
      return $parent.removeClass(this.selectedClass);
    }
  };

  ShiftCheckbox.prototype.events = {
    "click :checkbox": "selectOneOrMany",
    "change :checkbox": "updateParentClass"
  };

  function ShiftCheckbox(options, callback) {
    this.callback = callback;
    ShiftCheckbox.__super__.constructor.apply(this, arguments);
  }

  ShiftCheckbox.prototype.selected = function() {
    return (this.$(this.parentSelector)).has(":checkbox:checked").not(":has(." + this.selectAllClass + ")");
  };

  ShiftCheckbox.prototype.destroy = function() {
    (this.$(this.parentSelector)).has(":checkbox").removeClass(this.selectedClass);
    return this.stopListening();
  };

  return ShiftCheckbox;

})(Spine.Controller);

module.exports = ShiftCheckbox;

//# sourceMappingURL=spine-shift-checkbox.js.map
